#!/usr/bin/python3
# -*-coding:Utf-8 -*
#  version 2 avec enregistrement d'un fichier journal
import csv
import sys
import os
from PyQt5.QtWidgets import *
import smtplib
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.mime.base import MIMEBase
from email import encoders
import time
import datetime


class Window(QWidget):
		
	def __init__(self, parent=None):
		super(Window, self).__init__(parent)
		self.setWindowTitle("Envoi d'une liste de fichiers à une liste de noms - P. Philip 2020")
		self.resize(1224,1024)
		
		self.fichConfig = 'configP.txt'
		
		self.LTitre=QLabel('Expéditeur :')

		self.Gcourriel = QGroupBox('Courriel')
		self.Efrom = QLineEdit()
		self.Efrom.setMinimumWidth(250)
		
		self.GSMTP = QGroupBox('Serveur SMTP')
		self.RBposte = QRadioButton("laposte.net")
		self.RBgmail = QRadioButton("gmail.com")
		self.RBorange = QRadioButton("orange.fr")
		self.RBposte.toggled.connect(self.btnstate)
		self.RBgmail.toggled.connect(self.btnstate)
		self.RBorange.toggled.connect(self.btnstate)
		
		self.ESMTP = QLineEdit()
		self.ESMTP.setText('smtp.laposte.net')
		self.Lport = QLabel('port :')
		self.Eport = QLineEdit()
		self.Eport.setText('587')
		
		self.Gmdp = QGroupBox('Mot de passe :')
		self.Emdp = QLineEdit()
		self.Emdp.setEchoMode(2)  #  ne pas afficher les caractères
		self.Emdp.setText("")
		self.Emdp.setMinimumWidth(150)
		
		self.GNqcm = QGroupBox('Sujet et corps du message :')
		self.ENqcm = QLineEdit()
		self.ENqcm.setText("Corrigé du QCM ")
		self.ENqcm.setMinimumWidth(150)
		self.EMess = QTextEdit()
		self.EMess.setText("Voici le corrigé en pièce jointe. \nCordialement,\n")
		self.EMess.setMinimumWidth(150)
		
		self.tableau = QTableWidget()
		self.tableau.setRowCount(26)
		self.tableau.setColumnCount(4)
		self.tableau.setHorizontalHeaderLabels(['Nom','courriel','fichier','action'])
		self.tableau.setColumnWidth(0,150)
		self.tableau.setColumnWidth(1,250)
		self.tableau.setColumnWidth(2,250)
		self.tableau.setMinimumWidth(800)

		self.Bfichiercsv = QPushButton('fichier de noms')
		self.Bfichiercsv.clicked.connect(self.fichiercsv)
		
		self.LNomFichiercsv = QLabel('---')

		self.Bdossier = QPushButton('dossier des PJ')
		self.Bdossier.clicked.connect(self.PJ)
		
		self.LPJ=QLabel('---')
		
		self.Bassocier = QPushButton('associer les PJ')
		self.Bassocier.clicked.connect(self.associer)
		
		self.Lassocier = QLabel('Attente')
		
		self.Benvoi = QPushButton('envoi')
		self.Benvoi.clicked.connect(self.envoiTous)
		
		self.Lenvoi = QLabel('Attente')

		self.Gjournal = QGroupBox("Journal de l'envoi")
		self.Ljournal =  QLabel('')
		self.Ljournal.setWordWrap(True)
		
		styleT = """
		.QLabel {
			font-family:"Ubuntu",arial;
			font-size: 14pt;
			text-align : center;
			}
		"""	
		styleR = """
		.QLabel {
			border: 2px solid #d70e0e;
			border-radius: 10px;
			background-color: #efefef;
			font-family:"Liberation sans",arial, serif;
			font-size: 10pt;
			text-align : center;
			}
		"""	
		self.styleO = """
		.QLabel {
			border: 2px solid #e8a30f;
			border-radius: 10px;
			background-color: #efefef;
			font-family:"Liberation sans",arial, serif;
			font-size: 10pt;
			text-align : center;
			}
		"""	
		self.styleV = """
		.QLabel {
			border: 2px solid #33e80f;
			border-radius: 10px;
			background-color: #efefef;
			font-family:"Liberation sans",arial, serif;
			font-size: 10pt;
			text-align : center;
			}
		"""	
		self.LTitre.setStyleSheet(styleT)
		self.LNomFichiercsv.setStyleSheet(styleR)
		self.LPJ.setStyleSheet(styleR)
		self.Lassocier.setStyleSheet(styleR)
		self.Lenvoi.setStyleSheet(styleR)
		#  ----------------------------------------------------layouts
		layout = QVBoxLayout()  #  layout principal
		layoutCourriel = QVBoxLayout()
		layoutSMTP = QVBoxLayout()
		layoutmdp = QVBoxLayout()
		layoutNqcm = QVBoxLayout()
		layoutGrpejournal = QVBoxLayout()
		layoutBL = QHBoxLayout()  #  layout boutons et labels
		layoutBcsv = QVBoxLayout()  #  layout bouton et label csv
		layoutBPJ = QVBoxLayout()  #  layout bouton et label PJ
		layoutBA = QVBoxLayout()  #  layout associer et label
		layoutBE = QVBoxLayout()  #  layout envoi et label
		layoutH = QHBoxLayout()  #  layout tableau et Nom
		layoutNom = QVBoxLayout()  #  layout nom, adresse, etc
		
		layoutNom.addWidget(self.LTitre)
		layoutCourriel.addWidget(self.Efrom)
		layoutCourriel.addStretch(1)
		self.Gcourriel.setLayout(layoutCourriel)
		layoutNom.addWidget(self.Gcourriel)
		
		layoutSMTP.addWidget(self.RBposte)
		layoutSMTP.addWidget(self.RBgmail)
		layoutSMTP.addWidget(self.RBorange)
		layoutSMTP.addWidget(self.ESMTP)
		layoutSMTP.addWidget(self.Lport)
		layoutSMTP.addWidget(self.Eport)
		layoutSMTP.addStretch(1)
		self.GSMTP.setLayout(layoutSMTP)
		layoutNom.addWidget(self.GSMTP)

		layoutmdp.addWidget(self.Emdp)
		layoutmdp.addStretch(1)
		self.Gmdp.setLayout(layoutmdp)
		layoutNom.addWidget(self.Gmdp)
		
		layoutNqcm.addWidget(self.ENqcm)
		layoutNqcm.addStretch(1)
		layoutNqcm.addWidget(self.EMess)
		self.GNqcm.setLayout(layoutNqcm)
		layoutNom.addWidget(self.GNqcm)
		
		layoutGrpejournal.addWidget(self.Ljournal)
		layoutNom.addStretch(1)
		self.Gjournal.setLayout(layoutGrpejournal)
		layoutNom.addWidget(self.Gjournal)
		
		layoutBcsv.addWidget(self.Bfichiercsv)
		layoutBcsv.addWidget(self.LNomFichiercsv)
		layoutBcsv.setContentsMargins(10,0,10,0)
		layoutBL.addLayout(layoutBcsv)
		layoutBPJ.addWidget(self.Bdossier)
		layoutBPJ.addWidget(self.LPJ)
		layoutBL.addLayout(layoutBPJ)
		layoutBcsv.setContentsMargins(10,0,10,0)
		
		layoutBA.addWidget(self.Bassocier)
		layoutBA.addWidget(self.Lassocier)
		layoutBE.addWidget(self.Benvoi)
		layoutBE.addWidget(self.Lenvoi)

		layoutBL.addLayout(layoutBA)
		layoutBL.addLayout(layoutBE)
		
		layoutH.addLayout(layoutNom)
		layoutH.addWidget(self.tableau)
		
		layout.addLayout(layoutBL)
		layout.addLayout(layoutH)

		self.setLayout(layout)
		
		#  initialisations
		self.Bdossier.setEnabled(False)
		self.Bassocier.setEnabled(False)
		self.Benvoi.setEnabled(False)
		self.RBposte.setChecked(True)
		self.bien_passe = True
		self.stopEnvoi = False

	def btnstate(self):
		if self.RBposte.isChecked():
			self.ESMTP.setText('smtp.laposte.net')
			self.Eport.setText('587')
		else:
			if self.RBgmail.isChecked():
				self.ESMTP.setText('smtp.gmail.com')
				self.Eport.setText('465')
			else:
				if self.RBorange.isChecked():
					self.ESMTP.setText('smtp.orange.fr')
					self.Eport.setText('465')

	def fichiercsv(self):
		listeFichier = QFileDialog.getOpenFileName(self,"ouvrir une liste de noms", os.path.curdir, "csv Files (*.csv)")
		#  traitement seulement si on a choisi un fichier
		if listeFichier[0] != '':
			self.NomFichcsv = listeFichier[0]
			#  enregistrer le chemin dans la config
			with open(self.fichConfig,'w') as Fconf:
				Fconf.write(self.NomFichcsv)
			
			self.LNomFichiercsv.setText(self.NomFichcsv)
			self.LNomFichiercsv.setStyleSheet(self.styleV)
			
			self.fichierLu = self.lireAfficher()

	def lireAfficher(self):
		try:
			with open(self.NomFichcsv,newline='') as csvfile:
				reader = csv.reader(csvfile)
				self.tableau.clear()
				j = 0
				l = []
				liste = list(reader)
				longueur = len(liste)
				self.tableau.setRowCount(longueur + 1)  #  ajuste le tableau au nombre de noms
				for row in liste:
					nom = QTableWidgetItem(row[0])
					self.tableau.setItem(j, 0, nom)
					courriel = QTableWidgetItem(row[1])
					self.tableau.setItem(j, 1, courriel)
					fichier = QTableWidgetItem('---')
					self.tableau.setItem(j, 2, fichier)
					etat = QTableWidgetItem('en attente')
					self.tableau.setItem(j, 3, etat)
					l.append(row)
					j = j+1
				self.Bdossier.setEnabled(True)
		except: 
			l = ['problème','de','lecture']
			
			nom = QTableWidgetItem('problème')
			self.tableau.setItem(0, 0, nom)
			courriel = QTableWidgetItem('de')
			self.tableau.setItem(0, 1, courriel)
			etat = QTableWidgetItem('lecture')
			self.tableau.setItem(0, 2, etat)

		return l
		
	def PJ(self):
		dialog = QFileDialog()
		dialog.setFileMode(QFileDialog.Directory)
		dialog.setOption(QFileDialog.ShowDirsOnly)
		self.dossierPJ = dialog.getExistingDirectory(self, 'Dossier des pièces jointes', os.path.curdir)
		self.LPJ.setText(self.dossierPJ)
		self.LPJ.setStyleSheet(self.styleV)
		self.Bassocier.setEnabled(True)
		
	def associer(self):
		fichiers = [f for f in os.listdir(self.dossierPJ)]
		print(fichiers)
		i=0
		for item in self.fichierLu:
			print(item)
			
			for f in fichiers:
				print(item[0])
				print(f)
				if f.find(item[0])!=-1: 
					resultat=f
					case3=QTableWidgetItem(resultat)
					self.tableau.setItem(i, 2, case3)
			
			i = i+1
		
		self.Benvoi.setEnabled(True)
		self.Lassocier.setStyleSheet(self.styleV)
		self.Lassocier.setText('OK')
	
	def envoi(self,fromaddr, toaddr, filepath, filename, SMTP, port, mdp, nomQCM='', corps='En pièce jointe.'):
		msg = MIMEMultipart()
		e = ''
		msg['From'] = fromaddr
		msg['To'] = toaddr
		msg['Subject'] = nomQCM
		 
		body = corps
		 
		msg.attach(MIMEText(body, 'plain'))
		 
		attachment = open(filepath+filename, "rb")

		part = MIMEBase('application', 'octet-stream')
		part.set_payload((attachment).read())
		encoders.encode_base64(part)
		part.add_header('Content-Disposition', "attachment; filename= %s" % filename)
		 
		msg.attach(part)
		try:
			server = smtplib.SMTP(SMTP, port)
			server.starttls()
			server.login(fromaddr, mdp)
			text = msg.as_string()
			server.sendmail(fromaddr, toaddr, text)
			server.quit()
			print(str(sys.exc_info()[0]))
		except smtplib.SMTPRecipientsRefused:
			e = 'adresse ' + toaddr + ' invalide'
		except smtplib.socket.gaierror:
			e = 'SMTP invalide'
			self.stopEnvoi = True
		except smtplib.SMTPAuthenticationError:
			e = 'mauvais mot de passe ou adresse'
			self.stopEnvoi = True
		
		if e != '':
			journal = self.Ljournal.text()
			journal = journal + '\n' + e
			self.Ljournal.setText(journal)
			self.Ljournal.repaint()
			self.bien_passe = False
			with open('journaux.txt', 'a', newline='') as txtfile:
				txtfile.write('\n' + toaddr + ' : ' + e)
		else:
			with open('journaux.txt', 'a', newline='') as txtfile:
				txtfile.write('\n' + toaddr)
	
	def ModLenvoi(self,style,texte):
		self.Lenvoi.setStyleSheet(style)
		self.Lenvoi.setText(texte)
		self.Lenvoi.repaint()

	def ModTableau(self,i,j,texte):
		etat=QTableWidgetItem(texte)
		self.tableau.setItem(i, j, etat)
		self.tableau.repaint()
	
	def envoiTous(self):
		self.Ljournal.setText('')
		self.stopEnvoi = False
		self.bien_passe = True
		self.ModLenvoi(self.styleO,"En cours")

		#  écriture de l'en-tête du fichier journal
		with open('journaux.txt', 'a', newline='') as txtfile:
			txtfile.write('\n' + '\n' + '________________________________________________________')
			txtfile.write('\n' + str(datetime.datetime.now()) + ' Expéditeur : ' + self.Efrom.text() + '  Sujet : ' + self.ENqcm.text())

		for j in range(len(self.fichierLu)):
			if (self.tableau.item(j,2).text() != '---') and not(self.stopEnvoi):
				self.ModTableau(j, 3, 'Envoi') 
				print('envoi')
				time.sleep(5)
				print((self.EMess.toPlainText()))
				self.envoi(self.Efrom.text(), self.tableau.item(j,1).text(), self.dossierPJ+'/', self.tableau.item(j,2).text(), self.ESMTP.text(), int(self.Eport.text()), self.Emdp.text(), self.ENqcm.text(), self.EMess.toPlainText())
				etat = QTableWidgetItem('Terminé.')
				self.tableau.setItem(j, 3, etat)
				self.ModTableau(j, 3, 'Terminé')

		if self.bien_passe:
			self.ModLenvoi(self.styleV,'Terminé.')
			with open('journaux.txt', 'a', newline='') as txtfile:
				txtfile.write('\n' + "Fin de l'envoi : " + 'OK')
		else:
			self.ModLenvoi(self.styleO, 'Terminé avec des erreurs')
			with open('journaux.txt', 'a', newline='') as txtfile:
				txtfile.write('\n' + "Fin de l'envoi : " + 'Des erreurs.')
		
		
if __name__ == '__main__':
	app = QApplication(sys.argv)

	main = Window()
	main.show()
	
	app.exec_()

